Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class JList

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.JList

public class JList
extends JComponent
implements Scrollable, Accessible

A component that allows the user to select one or more objects from a list. A separate model, `ListModel`, represents the contents of the list. It's easy to display an array or vector of objects, using a `JList` constructor that builds an `ListModel` instance for you:

     // Create a JList that displays the strings in data[]

     String[] data = {"one", "two", "free", "four"};
     JList dataList = new JList(data);

     // The value of the JList model property is an object that provides
     // a read-only view of the data.  It was constructed automatically.

     for(int i = 0; i < dataList.getModel().getSize(); i++) {
         System.out.println(dataList.getModel().getElementAt(i));
     }

     // Create a JList that displays the superclass of JList.class.
     // We store the superclasses in a java.util.Vector.

     Vector superClasses = new Vector();
     Class rootClass = javax.swing.JList.class;
     for(Class cls = rootClass; cls != null; cls = cls.getSuperclass()) {
         superClasses.addElement(cls);
     }
     JList classList = new JList(superClasses);

JList doesn't support scrolling directly. To create a scrolling list you make the JList the viewport view of a JScrollPane, e.g.

     JScrollPane scrollPane = new JScrollPane(dataList);
     // Or in two steps:
     JScrollPane scrollPane = new JScrollPane();
     scrollPane.getViewport().setView(dataList);

By default `JList` supports single selection, i.e. zero or one index can be selected. The selection state is actually managed by a separate delegate object, an implementation of `ListSelectionModel` however `JList` provides convenient properties for managing the selection.

     String[] data = {"one", "two", "free", "four"};
     JList dataList = new JList(data);

     dataList.setSelectedIndex(1);  // select "two"
     dataList.getSelectedValue();   // returns "two"

The contents of a `JList` can be dynamic, i.e. the list elements can change value and the size of the list can change after the JList has been created. The `JList` observes changes in its model with a `swing.event.ListDataListener` implementation. A correct implementation of `ListModel` notifies it's listeners each time a change occurs. The changes are characterized by a `swing.event.ListDataEvent`, which identifies the range of List indices that have been modified, added, or removed. Simple dynamic-content `JList` applications can use the `DefaultListModel` class to store list elements. This class implements the `ListModel` interface and provides the `java.util.Vector` API as well. Applications that need to provide custom `ListModel` implementations can subclass `AbstractListModel`, which provides basic `ListDataListener` support. For example:

     // This list model has about 2^16 elements.  Enjoy scrolling.

     ListModel bigData = new AbstractListModel() {
         public int getSize() { return Short.MAX_VALUE; }
         public Object getElementAt(int index) { return "Index " + index; }
     };

     JList bigDataList = new List(bigData);

     // We don't want the JList implementation to compute the width
     // or height of all of the list cells, so we give it a String
     // that's as big as we'll need for any cell.  It uses this to
     // compute values for the fixedCellWidth and fixedCellHeight
     // properties.

     bigDataList.setPrototypeCellValue("Index 1234567890");

`JList` uses a `java.awt.Component`, provided by a delegate called the `cellRendererer`, to paint the visible cells in the list. The cell renderer component is used like a "rubber stamp" to paint each visible row. Each time the `JList` needs to paint a cell it asks the cell renderer for the component, moves it into place using `setBounds()` and then draws it by calling its paint method. The default cell renderer uses a `JLabel` component to render the string value of each component. You can substitute your own cell renderer, using code like this:

      // Display an icon and a string for each object in the list.

     class MyCellRenderer extends JLabel implements ListCellRenderer {
         final static ImageIcon longIcon = new ImageIcon("long.gif");
         final static ImageIcon shortIcon = new ImageIcon("short.gif");

         // This is the only method defined by ListCellRenderer.  We just
         // reconfigure the Jlabel each time we're called.

         public Component getListCellRendererComponent(
           JList list,
           Object value,            // value to display
           int index,               // cell index
           boolean isSelected,      // is the cell selected
           boolean cellHasFocus)    // the list and the cell have the focus
         {
            String s = value.toString();
             setText(s);
             setIcon((s.length > 10) ? longIcon : shortIcon);
          return this;
         }
     }

     String[] data = {"one", "two", "free", "four"};
     JList dataList = new JList(data);
     dataList.setCellRenderer(new MyCellRenderer());

`JList` doesn't provide any special support for handling double or triple (or N) mouse clicks however it's easy to handle them using a `MouseListener`. Use the `JList` method `locationToIndex()` to determine what cell was clicked. For example:

     final JList list = new JList(dataModel);
     MouseListener mouseListener = new MouseAdapter() {
         public void mouseClicked(MouseEvent e) {
             if (e.getClickCount() == 2) {
                 int index = list.locationToIndex(e.getPoint());
                 System.out.println("Double clicked on Item " + index);
              }
         }
     };
     list.addMouseListener(mouseListener);

Note that in this example the JList variable is `final` because it's referred to by the anonymous MouseListener class.

For the keyboard keys used by this component in the standard Look and Feel (L&F) renditions, see the JList key assignments.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `ListModel`, `AbstractListModel`, `DefaultListModel`, `ListSelectionModel`, `DefaultListSelectionModel`, `ListCellRenderer`, Serialized Form

Inner Class Summary
`protected class` | `JList.AccessibleJList` The class used to obtain the accessible role for this object.

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Constructor Summary
`JList()` Constructs a JList with an empty model.
`JList(ListModel dataModel)` Construct a JList that displays the elements in the specified, non-null model.
`JList(java.lang.Object[] listData)` Construct a JList that displays the elements in the specified array.
`JList(java.util.Vector listData)` Construct a JList that displays the elements in the specified Vector.

Method Summary
`void` | `addListSelectionListener(ListSelectionListener listener)` Add a listener to the list that's notified each time a change to the selection occurs.
`void` | `addSelectionInterval(int anchor, int lead)` Set the selection to be the union of the specified interval with current selection.
`void` | `clearSelection()` Clears the selection - after calling this method isSelectionEmpty() will return true.
`protected ListSelectionModel` | `createSelectionModel()` Returns an instance of DefaultListSelectionModel.
`void` | `ensureIndexIsVisible(int index)` If this JList is being displayed within a JViewport and the specified cell isn't completely visible, scroll the viewport.
`protected void` | `fireSelectionValueChanged(int firstIndex, int lastIndex, boolean isAdjusting)` This method notifies JList ListSelectionListeners that the selection model has changed.
`AccessibleContext` | `getAccessibleContext()` Get the AccessibleContext associated with this JComponent
`int` | `getAnchorSelectionIndex()` Returns the first index argument from the most recent addSelectionInterval or setSelectionInterval call.
`java.awt.Rectangle` | `getCellBounds(int index1, int index2)` Returns the bounds of the specified range of items in JList coordinates, null if index isn't valid.
`ListCellRenderer` | `getCellRenderer()` Returns the object that renders the list items.
`int` | `getFirstVisibleIndex()` Return the index of the cell in the upper left corner of the JList or -1 if nothing is visible or the list is empty.
`int` | `getFixedCellHeight()` Returns the fixed cell width value -- the value specified by setting the fixedCellHeight property, rather than calculated from the list elements.
`int` | `getFixedCellWidth()` Returns the fixed cell width value -- the value specified by setting the fixedCellWidth property, rather than calculated from the list elements.
`int` | `getLastVisibleIndex()` Return the index of the cell in the lower right corner of the JList or -1 if nothing is visible or the list is empty.
`int` | `getLeadSelectionIndex()` Returns the second index argument from the most recent addSelectionInterval or setSelectionInterval call.
`int` | `getMaxSelectionIndex()` Returns the largest selected cell index.
`int` | `getMinSelectionIndex()` Returns the smallest selected cell index.
`ListModel` | `getModel()` Returns the data model that holds the list of items displayed by the JList component.
`java.awt.Dimension` | `getPreferredScrollableViewportSize()` Compute the size of the viewport needed to display visibleRowCount rows.
`java.lang.Object` | `getPrototypeCellValue()` Returns the cell width of the "prototypical cell" -- a cell used for the calculation of cell widths, because it has the same value as all other list items, instead of forcing the calculation to inspect every item in the list.
`int` | `getScrollableBlockIncrement(java.awt.Rectangle visibleRect, int orientation, int direction)` Returns the block increment amount.
`boolean` | `getScrollableTracksViewportHeight()` If this JList is displayed in a JViewport, don't change its height when the viewports height changes.
`boolean` | `getScrollableTracksViewportWidth()` If this JList is displayed in a JViewport, don't change its width when the viewports width changes.
`int` | `getScrollableUnitIncrement(java.awt.Rectangle visibleRect, int orientation, int direction)` Horizontal scrolling: return the lists font size or 1 if the font is null.
`int` | `getSelectedIndex()` A convenience method that returns the first selected index.
`int[]` | `getSelectedIndices()` Return an array of all of the selected indices in increasing order.
`java.lang.Object` | `getSelectedValue()` A convenience method that returns the first selected value or null, if the selection is empty.
`java.lang.Object[]` | `getSelectedValues()` Return an array of the values for the selected cells.
`java.awt.Color` | `getSelectionBackground()` Returns the background color for selected cells.
`java.awt.Color` | `getSelectionForeground()` Returns the foreground color.
`int` | `getSelectionMode()` Returns whether single-item or multiple-item selections are allowed.
`ListSelectionModel` | `getSelectionModel()` Returns the value of the current selection model.
`ListUI` | `getUI()` Returns the L&F object that renders this component.
`java.lang.String` | `getUIClassID()` Returns the name of the UIFactory class that generates the look and feel for this component.
`boolean` | `getValueIsAdjusting()` Returns the value of the data model's isAdjusting property.
`int` | `getVisibleRowCount()` Return the preferred number of visible rows.
`java.awt.Point` | `indexToLocation(int index)` Returns the origin of the specified item in JList coordinates, null if index isn't valid.
`boolean` | `isSelectedIndex(int index)` Returns true if the specified index is selected.
`boolean` | `isSelectionEmpty()` Returns true if nothing is selected This is a convenience method that just delegates to the selectionModel.
`int` | `locationToIndex(java.awt.Point location)` Convert a point in JList coordinates to the index of the cell at that location.
`protected java.lang.String` | `paramString()` Returns a string representation of this JList.
`void` | `removeListSelectionListener(ListSelectionListener listener)` Remove a listener from the list that's notified each time a change to the selection occurs.
`void` | `removeSelectionInterval(int index0, int index1)` Set the selection to be the set difference of the specified interval and the current selection.
`void` | `setCellRenderer(ListCellRenderer cellRenderer)` Sets the delegate that's used to paint each cell in the list.
`void` | `setFixedCellHeight(int height)` If this value is greater than zero it defines the height of every cell in the list.
`void` | `setFixedCellWidth(int width)` If this value is greater than zero it defines the width of every cell in the list.
`void` | `setListData(java.lang.Object[] listData)` A convenience method that constructs a ListModel from an array of Objects and then applies setModel to it.
`void` | `setListData(java.util.Vector listData)` A convenience method that constructs a ListModel from a Vector and then applies setModel to it.
`void` | `setModel(ListModel model)` Sets the model that represents the contents or "value" of the list and clears the list selection after notifying PropertyChangeListeners.
`void` | `setPrototypeCellValue(java.lang.Object prototypeCellValue)` If this value is non-null it's used to compute fixedCellWidth and fixedCellHeight by configuring the cellRenderer at index equals zero for the specified value and then computing the renderer components preferred size.
`void` | `setSelectedIndex(int index)` Select a single cell.
`void` | `setSelectedIndices(int[] indices)` Select a set of cells.
`void` | `setSelectedValue(java.lang.Object anObject, boolean shouldScroll)` Selects the specified object from the list.
`void` | `setSelectionBackground(java.awt.Color selectionBackground)` Set the background color for selected cells.
`void` | `setSelectionForeground(java.awt.Color selectionForeground)` Set the foreground color for selected cells.
`void` | `setSelectionInterval(int anchor, int lead)` Select the specified interval.
`void` | `setSelectionMode(int selectionMode)` Determines whether single-item or multiple-item selections are allowed.
`void` | `setSelectionModel(ListSelectionModel selectionModel)` Set the selectionModel for the list to a non-null ListSelectionModel implementation.
`void` | `setUI(ListUI ui)` Sets the L&F object that renders this component.
`void` | `setValueIsAdjusting(boolean b)` Sets the data model's isAdjusting property true, so that a single event will be generated when all of the selection events have finished (for example, when the mouse is being dragged over the list in selection mode).
`void` | `setVisibleRowCount(int visibleRowCount)` Set the preferred number of rows in the list that can be displayed without a scollbar, as determined by the nearest JViewport ancestor, if any.
`void` | `updateUI()` Set the UI property with the "ListUI" from the current default UIFactory.

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getGraphics, getHeight, getInsets, getInsets, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, isDoubleBuffered, isFocusCycleRoot, isFocusTraversable, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, processComponentKeyEvent, processFocusEvent, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDoubleBuffered, setEnabled, setFont, setForeground, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setUI, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, countComponents, deliverEvent, doLayout, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getLayout, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setLayout, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, createImage, createImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, getBackground, getBounds, getColorModel, getCursor, getFont, getFontMetrics, getForeground, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hide, imageUpdate, inside, isEnabled, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processMouseEvent, remove, removeComponentListener, removeFocusListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### JList

    public JList(ListModel dataModel)

  Construct a JList that displays the elements in the specified, non-null model. All JList constructors delegate to this one.

### JList

    public JList(java.lang.Object[] listData)

  Construct a JList that displays the elements in the specified array. This constructor just delegates to the ListModel constructor.

### JList

    public JList(java.util.Vector listData)

  Construct a JList that displays the elements in the specified Vector. This constructor just delegates to the ListModel constructor.

### JList

    public JList()

  Constructs a JList with an empty model.

Method Detail

### getUI

    public ListUI getUI()

  Returns the L&F object that renders this component.
  Returns:
    the ListUI object that renders this component

### setUI

    public void setUI(ListUI ui)

  Sets the L&F object that renders this component.
  Parameters:
    `ui` - the ListUI L&F object
  See Also:
    `UIDefaults.getUI(javax.swing.JComponent)`

### updateUI

    public void updateUI()

  Set the UI property with the "ListUI" from the current default UIFactory. This method is called by the JList constructor and to update the Lists look and feel at runtime.
  Overrides:
    updateUI in class JComponent
  See Also:
    `UIManager.getUI(javax.swing.JComponent)`

### getUIClassID

    public java.lang.String getUIClassID()

  Returns the name of the UIFactory class that generates the look and feel for this component.
  Returns:
    "ListUI"
  Overrides:
    getUIClassID in class JComponent
  See Also:
    `JComponent.getUIClassID()`, `UIDefaults.getUI(javax.swing.JComponent)`

### getPrototypeCellValue

    public java.lang.Object getPrototypeCellValue()

  Returns the cell width of the "prototypical cell" -- a cell used for the calculation of cell widths, because it has the same value as all other list items, instead of forcing the calculation to inspect every item in the list.
  Returns:
    the value of the prototypeCellValue property
  See Also:
    `setPrototypeCellValue(java.lang.Object)`

### setPrototypeCellValue

    public void setPrototypeCellValue(java.lang.Object prototypeCellValue)

  If this value is non-null it's used to compute fixedCellWidth and fixedCellHeight by configuring the cellRenderer at index equals zero for the specified value and then computing the renderer components preferred size. This property is useful when the list is too long to allow JList to just compute the width/height of each cell and there's single cell value that's known to occupy as much space as any of the others.

  The default value of this property is null.

  This is a JavaBeans bound property. Note that we do set the fixedCellWidth and fixedCellHeight properties here but only a prototypeCellValue PropertyChangeEvent is fired.

  Parameters:
    `the` - value to base fixedCellWidth and fixedCellHeight on
  See Also:
    `getPrototypeCellValue()`, `setFixedCellWidth(int)`, `setFixedCellHeight(int)`, `JComponent.addPropertyChangeListener(java.beans.PropertyChangeListener)`

### getFixedCellWidth

    public int getFixedCellWidth()

  Returns the fixed cell width value -- the value specified by setting the fixedCellWidth property, rather than calculated from the list elements.
  Returns:
    the fixed cell width
  See Also:
    `setFixedCellWidth(int)`

### setFixedCellWidth

    public void setFixedCellWidth(int width)

  If this value is greater than zero it defines the width of every cell in the list. Otherwise cell widths are computed by applying getPreferredSize() to the cellRenderer component for each list element.

  The default value of this property is -1.

  This is a JavaBeans bound property.

  Parameters:
    `the` - width for all cells in this list
  See Also:
    `getPrototypeCellValue()`, `setFixedCellWidth(int)`, `JComponent.addPropertyChangeListener(java.beans.PropertyChangeListener)`

### getFixedCellHeight

    public int getFixedCellHeight()

  Returns the fixed cell width value -- the value specified by setting the fixedCellHeight property, rather than calculated from the list elements.
  Returns:
    the fixed cell height
  See Also:
    `setFixedCellHeight(int)`

### setFixedCellHeight

    public void setFixedCellHeight(int height)

  If this value is greater than zero it defines the height of every cell in the list. Otherwise cell heights are computed by applying getPreferredSize() to the cellRenderer component for each list element.

  The default value of this property is -1.

  This is a JavaBeans bound property.

  Parameters:
    `height` - an int giving the height in pixels for all cells in this list
  See Also:
    `getPrototypeCellValue()`, `setFixedCellWidth(int)`, `JComponent.addPropertyChangeListener(java.beans.PropertyChangeListener)`

### getCellRenderer

    public ListCellRenderer getCellRenderer()

  Returns the object that renders the list items.
  Returns:
    the ListCellRenderer
  See Also:
    `setCellRenderer(javax.swing.ListCellRenderer)`

### setCellRenderer

    public void setCellRenderer(ListCellRenderer cellRenderer)

  Sets the delegate that's used to paint each cell in the list. If prototypeCellValue was set then the fixedCellWidth and fixedCellHeight properties are set as well. Only one PropertyChangeEvent is generated however - for the "cellRenderer" property.

  The default value of this property is provided by the ListUI delegate, i.e. by the look and feel implementation.

  This is a JavaBeans bound property.

  Parameters:
    `cellRenderer` - the ListCellRenderer that paints list cells
  See Also:
    `getCellRenderer()`

### getSelectionForeground

    public java.awt.Color getSelectionForeground()

  Returns the foreground color.
  Returns:
    the Color object for the foreground property
  See Also:
    `setSelectionForeground(java.awt.Color)`, `setSelectionBackground(java.awt.Color)`

### setSelectionForeground

    public void setSelectionForeground(java.awt.Color selectionForeground)

  Set the foreground color for selected cells. Cell renderers can use this color to render text and graphics for selected cells.

  The default value of this property is defined by the look and feel implementation.

  This is a JavaBeans bound property.

  Parameters:
    `selectionForeground` - the Color to use in the foreground for selected list items
  See Also:
    `getSelectionForeground()`, `setSelectionBackground(java.awt.Color)`, `JComponent.setForeground(java.awt.Color)`, `JComponent.setBackground(java.awt.Color)`, `JComponent.setFont(java.awt.Font)`

### getSelectionBackground

    public java.awt.Color getSelectionBackground()

  Returns the background color for selected cells.
  Returns:
    the Color used for the background of selected list items
  See Also:
    `setSelectionBackground(java.awt.Color)`, `setSelectionForeground(java.awt.Color)`

### setSelectionBackground

    public void setSelectionBackground(java.awt.Color selectionBackground)

  Set the background color for selected cells. Cell renderers can use this color to the fill selected cells.

  The default value of this property is defined by the look and feel implementation.

  This is a JavaBeans bound property.

  Parameters:
    `selectionBackground` - the Color to use for the background of selected cells
  See Also:
    `getSelectionBackground()`, `setSelectionForeground(java.awt.Color)`, `JComponent.setForeground(java.awt.Color)`, `JComponent.setBackground(java.awt.Color)`, `JComponent.setFont(java.awt.Font)`

### getVisibleRowCount

    public int getVisibleRowCount()

  Return the preferred number of visible rows.
  Returns:
    an int indicating the preferred number of rows to display without using a scrollbar
  See Also:
    `setVisibleRowCount(int)`

### setVisibleRowCount

    public void setVisibleRowCount(int visibleRowCount)

  Set the preferred number of rows in the list that can be displayed without a scollbar, as determined by the nearest JViewport ancestor, if any. The value of this property only affects the value of the JLists preferredScrollableViewportSize.

  The default value of this property is 8.

  This is a JavaBeans bound property.

  Parameters:
    `visibleRowCount` - an int specifying the preferred number of visible rows
  See Also:
    `getVisibleRowCount()`, `JComponent.getVisibleRect()`, `JViewport`

### getFirstVisibleIndex

    public int getFirstVisibleIndex()

  Return the index of the cell in the upper left corner of the JList or -1 if nothing is visible or the list is empty. Note that this cell may only be partially visible.
  Returns:
    an int -- the index of the first visible cell.
  See Also:
    `getLastVisibleIndex()`, `JComponent.getVisibleRect()`

### getLastVisibleIndex

    public int getLastVisibleIndex()

  Return the index of the cell in the lower right corner of the JList or -1 if nothing is visible or the list is empty. Note that this cell may only be partially visible.
  Returns:
    an int -- the index of the last visible cell.
  See Also:
    `getLastVisibleIndex()`, `JComponent.getVisibleRect()`

### ensureIndexIsVisible

    public void ensureIndexIsVisible(int index)

  If this JList is being displayed within a JViewport and the specified cell isn't completely visible, scroll the viewport.
  Parameters:
    `an` - int -- the index of the cell to make visible
  See Also:
    `JComponent.scrollRectToVisible(java.awt.Rectangle)`, `JComponent.getVisibleRect()`

### locationToIndex

    public int locationToIndex(java.awt.Point location)

  Convert a point in JList coordinates to the index of the cell at that location. Returns -1 if there's no cell the specified location.
  Parameters:
    `location` - The JList relative coordinates of the cell
  Returns:
    an int -- the index of the cell at the given location, or -1.

### indexToLocation

    public java.awt.Point indexToLocation(int index)

  Returns the origin of the specified item in JList coordinates, null if index isn't valid.
  Parameters:
    `index` - The index of the JList cell.
  Returns:
    The origin of the index'th cell.

### getCellBounds

    public java.awt.Rectangle getCellBounds(int index1,
                                            int index2)

  Returns the bounds of the specified range of items in JList coordinates, null if index isn't valid.
  Parameters:
    `index1` - the index of the first JList cell in the range
    `index2` - the index of the last JList cell in the range
  Returns:
    the bounds of the indexed cells

### getModel

    public ListModel getModel()

  Returns the data model that holds the list of items displayed by the JList component.
  Returns:
    the ListModel that provides the displayed list of items
  See Also:
    `setModel(javax.swing.ListModel)`

### setModel

    public void setModel(ListModel model)

  Sets the model that represents the contents or "value" of the list and clears the list selection after notifying PropertyChangeListeners.

  This is a JavaBeans bound property.

  Parameters:
    `model` - the ListModel that provides the list of items for display
  See Also:
    `getModel()`

### setListData

    public void setListData(java.lang.Object[] listData)

  A convenience method that constructs a ListModel from an array of Objects and then applies setModel to it.
  Parameters:
    `listData` - an array of Objects containing the items to display in the list
  See Also:
    `setModel(javax.swing.ListModel)`

### setListData

    public void setListData(java.util.Vector listData)

  A convenience method that constructs a ListModel from a Vector and then applies setModel to it.
  Parameters:
    `listData` - a Vector containing the items to display in the list
  See Also:
    `setModel(javax.swing.ListModel)`

### createSelectionModel

    protected ListSelectionModel createSelectionModel()

  Returns an instance of DefaultListSelectionModel. This method is used by the constructor to initialize the selectionModel property.
  Returns:
    The ListSelectionModel used by this JList.
  See Also:
    `setSelectionModel(javax.swing.ListSelectionModel)`, `DefaultListSelectionModel`

### getSelectionModel

    public ListSelectionModel getSelectionModel()

  Returns the value of the current selection model. The selection model handles the task of making single selections, selections of contiguous ranges, and non-contiguous selections.
  Returns:
    the ListSelectionModel that implements list selections
  See Also:
    `setSelectionModel(javax.swing.ListSelectionModel)`, `ListSelectionModel`

### fireSelectionValueChanged

    protected void fireSelectionValueChanged(int firstIndex,
                                             int lastIndex,
                                             boolean isAdjusting)

  This method notifies JList ListSelectionListeners that the selection model has changed. It's used to forward ListSelectionEvents from the selectionModel to the ListSelectionListeners added directly to the JList.
  See Also:
    `addListSelectionListener(javax.swing.event.ListSelectionListener)`, `removeListSelectionListener(javax.swing.event.ListSelectionListener)`, `EventListenerList`

### addListSelectionListener

    public void addListSelectionListener(ListSelectionListener listener)

  Add a listener to the list that's notified each time a change to the selection occurs. Listeners added directly to the JList will have their ListSelectionEvent.getSource() == this JList (instead of the ListSelectionModel).
  Parameters:
    `listener` - The ListSelectionListener to add.
  See Also:
    `getSelectionModel()`

### removeListSelectionListener

    public void removeListSelectionListener(ListSelectionListener listener)

  Remove a listener from the list that's notified each time a change to the selection occurs.
  Parameters:
    `listener` - The ListSelectionListener to remove.
  See Also:
    `addListSelectionListener(javax.swing.event.ListSelectionListener)`, `getSelectionModel()`

### setSelectionModel

    public void setSelectionModel(ListSelectionModel selectionModel)

  Set the selectionModel for the list to a non-null ListSelectionModel implementation. The selection model handles the task of making single selections, selections of contiguous ranges, and non-contiguous selections.

  This is a JavaBeans bound property.

  Returns:
    selectionModel the ListSelectionModel that implements list selections
  See Also:
    `getSelectionModel()`

### setSelectionMode

    public void setSelectionMode(int selectionMode)

  Determines whether single-item or multiple-item selections are allowed. The following selectionMode values are allowed:
  - `SINGLE_SELECTION` Only one list index can be selected at a time. In this mode the setSelectionInterval and addSelectionInterval methods are equivalent, and they only the first index argument is used.
  - `SINGLE_INTERVAL_SELECTION` One contiguous index interval can be selected at a time. In this mode setSelectionInterval and addSelectionInterval are equivalent.
  - `MULTIPLE_INTERVAL_SELECTION` In this mode, there's no restriction on what can be selected.
  Parameters:
    `selectionMode` - an int specifying the type of selections that are permissible
  See Also:
    `getSelectionMode()`

### getSelectionMode

    public int getSelectionMode()

  Returns whether single-item or multiple-item selections are allowed.
  Returns:
    The value of the selectionMode property.
  See Also:
    `setSelectionMode(int)`

### getAnchorSelectionIndex

    public int getAnchorSelectionIndex()

  Returns the first index argument from the most recent addSelectionInterval or setSelectionInterval call. This is a convenience method that just delegates to the selectionModel.
  Returns:
    The index that most recently anchored an interval selection.
  See Also:
    `ListSelectionModel.getAnchorSelectionIndex()`, `addSelectionInterval(int, int)`, `setSelectionInterval(int, int)`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### getLeadSelectionIndex

    public int getLeadSelectionIndex()

  Returns the second index argument from the most recent addSelectionInterval or setSelectionInterval call. This is a convenience method that just delegates to the selectionModel.
  Returns:
    The index that most recently ended a interval selection.
  See Also:
    `ListSelectionModel.getLeadSelectionIndex()`, `addSelectionInterval(int, int)`, `setSelectionInterval(int, int)`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### getMinSelectionIndex

    public int getMinSelectionIndex()

  Returns the smallest selected cell index. This is a convenience method that just delegates to the selectionModel.
  Returns:
    The smallest selected cell index.
  See Also:
    `ListSelectionModel.getMinSelectionIndex()`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### getMaxSelectionIndex

    public int getMaxSelectionIndex()

  Returns the largest selected cell index. This is a convenience method that just delegates to the selectionModel.
  Returns:
    The largest selected cell index.
  See Also:
    `ListSelectionModel.getMaxSelectionIndex()`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### isSelectedIndex

    public boolean isSelectedIndex(int index)

  Returns true if the specified index is selected. This is a convenience method that just delegates to the selectionModel.
  Returns:
    True if the specified index is selected.
  See Also:
    `ListSelectionModel.isSelectedIndex(int)`, `setSelectedIndex(int)`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### isSelectionEmpty

    public boolean isSelectionEmpty()

  Returns true if nothing is selected This is a convenience method that just delegates to the selectionModel.
  Returns:
    True if nothing is selected
  See Also:
    `ListSelectionModel.isSelectionEmpty()`, `clearSelection()`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### clearSelection

    public void clearSelection()

  Clears the selection - after calling this method isSelectionEmpty() will return true. This is a convenience method that just delegates to the selectionModel.
  See Also:
    `ListSelectionModel.clearSelection()`, `isSelectionEmpty()`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### setSelectionInterval

    public void setSelectionInterval(int anchor,
                                     int lead)

  Select the specified interval. Both the anchor and lead indices are included. It's not neccessary for anchor to be less than lead. This is a convenience method that just delegates to the selectionModel.
  Parameters:
    `anchor` - The first index to select
    `lead` - The last index to select
  See Also:
    `ListSelectionModel.setSelectionInterval(int, int)`, `addSelectionInterval(int, int)`, `removeSelectionInterval(int, int)`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### addSelectionInterval

    public void addSelectionInterval(int anchor,
                                     int lead)

  Set the selection to be the union of the specified interval with current selection. Both the anchor and lead indices are included. It's not neccessary for anchor to be less than lead. This is a convenience method that just delegates to the selectionModel.
  Parameters:
    `anchor` - The first index to add to the selection
    `lead` - The last index to add to the selection
  See Also:
    `ListSelectionModel.addSelectionInterval(int, int)`, `setSelectionInterval(int, int)`, `removeSelectionInterval(int, int)`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### removeSelectionInterval

    public void removeSelectionInterval(int index0,
                                        int index1)

  Set the selection to be the set difference of the specified interval and the current selection. Both the anchor and lead indices are removed. It's not neccessary for anchor to be less than lead. This is a convenience method that just delegates to the selectionModel.
  Parameters:
    `anchor` - The first index to remove from the selection
    `lead` - The last index to remove from the selection
  See Also:
    `ListSelectionModel.removeSelectionInterval(int, int)`, `setSelectionInterval(int, int)`, `addSelectionInterval(int, int)`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### setValueIsAdjusting

    public void setValueIsAdjusting(boolean b)

  Sets the data model's isAdjusting property true, so that a single event will be generated when all of the selection events have finished (for example, when the mouse is being dragged over the list in selection mode).
  Parameters:
    `b` - the boolean value for the property value
  See Also:
    `ListSelectionModel.setValueIsAdjusting(boolean)`

### getValueIsAdjusting

    public boolean getValueIsAdjusting()

  Returns the value of the data model's isAdjusting property. This value is true if multiple changes are being made.
  Returns:
    true if multiple selection-changes are occuring, as when the mouse is being dragged over the list
  See Also:
    `ListSelectionModel.getValueIsAdjusting()`

### getSelectedIndices

    public int[] getSelectedIndices()

  Return an array of all of the selected indices in increasing order.
  Returns:
    All of the selected indices, in increasing order.
  See Also:
    `removeSelectionInterval(int, int)`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### setSelectedIndex

    public void setSelectedIndex(int index)

  Select a single cell.
  Parameters:
    `index` - The index of the one cell to select
  See Also:
    `ListSelectionModel.setSelectionInterval(int, int)`, `isSelectedIndex(int)`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### setSelectedIndices

    public void setSelectedIndices(int[] indices)

  Select a set of cells.
  Parameters:
    `indices` - The indices of the cells to select
  See Also:
    `ListSelectionModel.addSelectionInterval(int, int)`, `isSelectedIndex(int)`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### getSelectedValues

    public java.lang.Object[] getSelectedValues()

  Return an array of the values for the selected cells. The returned values are sorted in increasing index order.
  Returns:
    the selected values
  See Also:
    `isSelectedIndex(int)`, `getModel()`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### getSelectedIndex

    public int getSelectedIndex()

  A convenience method that returns the first selected index. Returns -1 if there is no selected item.
  Returns:
    The first selected index.
  See Also:
    `getMinSelectionIndex()`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### getSelectedValue

    public java.lang.Object getSelectedValue()

  A convenience method that returns the first selected value or null, if the selection is empty.
  Returns:
    The first selected value.
  See Also:
    `getMinSelectionIndex()`, `getModel()`, `addListSelectionListener(javax.swing.event.ListSelectionListener)`

### setSelectedValue

    public void setSelectedValue(java.lang.Object anObject,
                                 boolean shouldScroll)

  Selects the specified object from the list.
  Parameters:
    `anObject` - the Object to select
    `shouldScroll` - true if the list should scroll to display the selected object

### getPreferredScrollableViewportSize

    public java.awt.Dimension getPreferredScrollableViewportSize()

  Compute the size of the viewport needed to display visibleRowCount rows. This is trivial if fixedCellWidth and fixedCellHeight were specified. Note that they can specified implicitly with the prototypeCellValue property. If fixedCellWidth wasn't specified, it's computed by finding the widest list element. If fixedCellHeight wasn't specified then we resort to heuristics:
  - If the model isn't empty we just multiply the height of the first row by visibleRowCount.
  - If the model is empty, i.e. JList.getModel().getSize() == 0, then we just allocate 16 pixels per visible row, and 256 pixels for the width (unless fixedCellWidth was set), and hope for the best.
  Specified by:
    getPreferredScrollableViewportSize in interface Scrollable
  See Also:
    `getPreferredScrollableViewportSize()`, `setPrototypeCellValue(java.lang.Object)`

### getScrollableUnitIncrement

    public int getScrollableUnitIncrement(java.awt.Rectangle visibleRect,
                                          int orientation,
                                          int direction)

  Horizontal scrolling: return the lists font size or 1 if the font is null. We're using the font size instead of the width of some canonical string, e.g. "m", because it's cheaper.

  Vertical scrolling: if we're scrolling downwards (`direction` is greater than 0), and the first row is completely visible with respect to `visibleRect`, then return its height. If we're scrolling downwards and the first row is only partially visible, return the height of the visible part of the first row. Similarly if we're scrolling upwards we return the height of the row above the first row, unless the first row is partially visible.

  Specified by:
    getScrollableUnitIncrement in interface Scrollable
  Returns:
    The distance to scroll to expose the next or previous row.
  See Also:
    `Scrollable.getScrollableUnitIncrement(java.awt.Rectangle, int, int)`

### getScrollableBlockIncrement

    public int getScrollableBlockIncrement(java.awt.Rectangle visibleRect,
                                           int orientation,
                                           int direction)

  Returns the block increment amount.
  Specified by:
    getScrollableBlockIncrement in interface Scrollable
  Returns:
    The visibleRect.height or visibleRect.width per the orientation.
  See Also:
    `Scrollable.getScrollableUnitIncrement(java.awt.Rectangle, int, int)`

### getScrollableTracksViewportWidth

    public boolean getScrollableTracksViewportWidth()

  If this JList is displayed in a JViewport, don't change its width when the viewports width changes. This allows horizontal scrolling if the JViewport is itself embedded in a JScrollPane.
  Specified by:
    getScrollableTracksViewportWidth in interface Scrollable
  Returns:
    False - don't track the viewports width.
  See Also:
    `Scrollable.getScrollableTracksViewportWidth()`

### getScrollableTracksViewportHeight

    public boolean getScrollableTracksViewportHeight()

  If this JList is displayed in a JViewport, don't change its height when the viewports height changes. This allows vertical scrolling if the JViewport is itself embedded in a JScrollPane.
  Specified by:
    getScrollableTracksViewportHeight in interface Scrollable
  Returns:
    False - don't track the viewports width.
  See Also:
    `Scrollable.getScrollableTracksViewportWidth()`

### paramString

    protected java.lang.String paramString()

  Returns a string representation of this JList. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

  Overriding paramString() to provide information about the specific new aspects of the JFC components.

  Returns:
    a string representation of this JList.
  Overrides:
    paramString in class JComponent

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Get the AccessibleContext associated with this JComponent
  Specified by:
    getAccessibleContext in interface Accessible
  Returns:
    the AccessibleContext of this JComponent
  Overrides:
    getAccessibleContext in class JComponent

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.